# fwd.pl -- HTTP forwarding
#

package forward;

sub permanent {
    local($root, $rest, $query) = @_;

    $main'out_headers{'URI'} = $main'out_headers{'Location'} = 
            ($query ? "$root$rest?$query" : "$root$rest");
    &main'MIME_header('moved', 'text/html');

    local(@oh) = %main'out_headers;
    print "(", join(")(", @oh), ")\n";
}

sub temporary {
    local($root, $rest, $query) = @_;

    $main'out_headers{'URI'} = $main'out_headers{'Location'} = 
            ($query ? "$root$rest?$query" : "$root$rest");
    &main'MIME_header('found', 'text/html');

    local(@oh) = %main'out_headers;
    print "(", join(")(", @oh), ")\n";
}

1;
